TTFParser
Date: 2017-05-25

org.apache.fontbox.ttf

## Class TTFParser

- java.lang.Object
- - org.apache.fontbox.ttf.TTFParser

- Direct Known Subclasses:
    OTFParser

      public class TTFParser
      extends java.lang.Object

  TrueType font file parser.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `TTFParser()` Constructor.
    `TTFParser(boolean isEmbedded)` Constructor.
    `TTFParser(boolean isEmbedded, boolean parseOnDemand)` Constructor.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected boolean` | `allowCFF()`
    `TrueTypeFont` | `parse(java.io.File ttfFile)` Parse a file and return a TrueType font.
    `TrueTypeFont` | `parse(java.io.InputStream inputStream)` Parse an input stream and return a TrueType font.
    `TrueTypeFont` | `parse(java.lang.String ttfFile)` Parse a file and return a TrueType font.
    `TrueTypeFont` | `parseEmbedded(java.io.InputStream inputStream)` Parse an input stream and return a TrueType font that is to be embedded.
    `protected TTFTable` | `readTable(TrueTypeFont font, java.lang.String tag)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TTFParser

          public TTFParser()

      Constructor.

    - #### TTFParser

          public TTFParser(boolean isEmbedded)

      Constructor.
      Parameters:
        `isEmbedded` - true if the font is embedded in PDF

    - #### TTFParser

          public TTFParser(boolean isEmbedded,
                   boolean parseOnDemand)

      Constructor.
      Parameters:
        `isEmbedded` - true if the font is embedded in PDF
        `parseOnDemand` - true if the tables of the font should be parsed on demand

  - ### Method Detail

    - #### parse

          public TrueTypeFont parse(java.lang.String ttfFile)
                             throws java.io.IOException

      Parse a file and return a TrueType font.
      Parameters:
        `ttfFile` - The TrueType font filename.
      Returns:
        A TrueType font.
      Throws:
        `java.io.IOException` - If there is an error parsing the TrueType font.

    - #### parse

          public TrueTypeFont parse(java.io.File ttfFile)
                             throws java.io.IOException

      Parse a file and return a TrueType font.
      Parameters:
        `ttfFile` - The TrueType font file.
      Returns:
        A TrueType font.
      Throws:
        `java.io.IOException` - If there is an error parsing the TrueType font.

    - #### parse

          public TrueTypeFont parse(java.io.InputStream inputStream)
                             throws java.io.IOException

      Parse an input stream and return a TrueType font.
      Parameters:
        `inputStream` - The TTF data stream to parse from. It will be closed before returning.
      Returns:
        A TrueType font.
      Throws:
        `java.io.IOException` - If there is an error parsing the TrueType font.

    - #### parseEmbedded

          public TrueTypeFont parseEmbedded(java.io.InputStream inputStream)
                                     throws java.io.IOException

      Parse an input stream and return a TrueType font that is to be embedded.
      Parameters:
        `inputStream` - The TTF data stream to parse from. It will be closed before returning.
      Returns:
        A TrueType font.
      Throws:
        `java.io.IOException` - If there is an error parsing the TrueType font.

    - #### allowCFF

          protected boolean allowCFF()

    - #### readTable

          protected TTFTable readTable(TrueTypeFont font,
                           java.lang.String tag)